#pragma once
#include "CommonType.h"
class CHttpFile;
class SendMemoController;

class FileUploadController
{
public:
	FileUploadController(CWnd *pProgressWnd, SendMemoController* pController);
	~FileUploadController(void);

	void Upload(const CString& strPath);
	bool StartNextThread(int index);
	bool Delete(int index, trid_t *ptrid);

	int GetFileAttachIndex()
	{
		return m_maxFileIndex;
	}

	void SetFileAttachIndex(int index)
	{
		m_maxFileIndex = index;
	}

	const std::wstring GetFileAttachID()
	{
		return Conversion::Utf8ToWide(m_attachID);
	}

	void SetFileAttachID(const std::string& attachID)
	{
		m_attachID = attachID;
	}

private:
	static UINT _UploadThread(LPVOID pParam);

	struct ThreadInfo
	{
		CWinThread* pUploadThread;
		CEvent* pStopEvent;
		UINT serverFileIndex;

		ThreadInfo(CWinThread* pThread, CEvent* pEvent, int index)
			: pUploadThread(pThread)
			, pStopEvent(pEvent) 
			, serverFileIndex(index)
		{
		}

		bool operator==(const ThreadInfo& threadInfo)
		{
			return serverFileIndex == threadInfo.serverFileIndex;
		}

	};

	CWnd* m_pProgressWnd;
	std::string m_attachID;
	std::vector<ThreadInfo> m_threadVector;
	SendMemoController* m_pSendMemoController;
	unsigned int m_maxFileIndex;
};

class UploadFile
{
public:
	struct ThreadData
	{
		CString filePath;
		CWnd* pProgressWnd;
		CEvent* pStopEvent;
		int	fileAttachIndex;
		std::string fileAttachId;

		ThreadData(const CString& strPath, CWnd* pWnd, CEvent* pEvent, int index, const std::string& attachId)
			: filePath(strPath)
			, pProgressWnd(pWnd)
			, pStopEvent(pEvent)
			, fileAttachIndex(index)
			, fileAttachId(attachId)
		{

		}
	};

	BOOL FileSend(ThreadData *pData);

private:
	CString MakePreFileData(const CString& strBoundary, const CString& strFileName);
	CString MakePostFileData(const CString& strBoundary, LPCWSTR strAttachId, const CString& strTicket, LPCWSTR strUserID, int nFileIndex);
	CString MakeRequestHeaders(const CString& strBoundary);
	void RequestPostData(CHttpFile* pHTTP, CString strFormData);
};